public class BinaryTree
{
  private int        value;
  private BinaryTree leftTree;
  private BinaryTree rightTree;

  public BinaryTree( int nodeValue,
                     BinaryTree leftChild,
                     BinaryTree rightChild )
  {
    value     = nodeValue;
    leftTree  = leftChild;
    rightTree = rightChild;
  }

  public int nodeCount()
  {
    if ( (leftTree == null) && (rightTree == null) )
      return 1;
    else if ( leftTree == null )
      return 1 + rightTree.nodeCount();
    else if ( rightTree == null )
      return 1 + leftTree.nodeCount();
    else
      return 1 + leftTree.nodeCount() + rightTree.nodeCount();
  }
  
  public int height()
  {
    if ( (leftTree == null) && (rightTree == null) )
      return 0;
    else if ( leftTree == null )
      return 1 + rightTree.height();
    else if ( rightTree == null )
      return 1 + leftTree.height();
    else
      return 1 + Math.max( leftTree.height(), rightTree.height() );
  }
}
