public class NonEmptyTree implements BinaryTree
{
  private int        value;
  private BinaryTree leftTree;
  private BinaryTree rightTree;

  public NonEmptyTree( int        nodeValue,
                       BinaryTree leftChild,
                       BinaryTree rightChild )
  {
    value     = nodeValue;
    leftTree  = leftChild;
    rightTree = rightChild;
  }

  public int nodeCount()
  {
    return 1 + leftTree.nodeCount() + rightTree.nodeCount();
  }

  public int height()
  {
    return 1 + Math.max( leftTree.height(), rightTree.height() );
  }
  
  public int max()
  {
    int maxChild = Math.max( leftTree.max(), rightTree.max() );
    return Math.max( value, maxChild );
  }
}
